

proc dndecode { wo g } {
	global news  newsread 

	set w1 "$wo.main"
	set wx "$wo.x"

	# Use tmp file to download
	set fn "$news(personal)/[clock format [clock seconds] -format %H%M%S].tmp"
	set om "w"

	set fd [open $fn $om]

	#  Get a time stamp for the Window name
	set nts [clock format [clock seconds] -format %H%M%S]
	set w ".$nts"
	set txt "G$nts"
	toplevel $w
	wm title $w "Decode"
	wm geometry $w $news(decode,geo)
	bind $w <Configure> "setgeo $w %W decode"

	set news($w,scale)   0
	set count 0
	scale $w.s -from 1 -to 100  -variable news($w,scale)  -label "Fetching Article"\
		-showvalue true -orient horizontal -length 400 -state disabled
	pack $w.s

	update
	#  Get a seperate connection for this Window
	set news($nts)  [connectit]
	if { $news($nts) == "" } {
		unset news($nts) 
		closewin $w
		return
	}

	#  Configure the header area

	socksend $news($nts) "group $g"
	if { [rescode [readsock $news($nts)] 211] } {
		disconnect $news($nts);
		closewin $nts
		return
	}

	set od [ordered $wo];
	set need [llength $od]
	set fcount 0
	set totlines 0

	foreach idx $od {

		incr fcount
		set l1 [$w1 get $idx]
		set a [lindex [split $l1] 0]
	
		#  Get the header to determine the number of lines
		set l [getheader $a $news($nts)]
		set lines [lindex $l 4]
		set news($w,scale) 0
		$w.s configure -to $lines \
			-label "Saving $fcount/$need ($lines lines)"
		update
	
		socksend $news($nts) "body $a"
		if { [rescode [readsock $news($nts)] 222] } {
			disconnect $news($nts);
			closewin $nts
			return
		}
		update
		
		set res [readsock $news($nts)]
		set count 1
		while { $res != "." } {
			incr count
			if { $count > 5 } {
				incr news($w,scale) $count
				incr totlines
				set count 0
				update
			}
			set res [string trim $res " "]
			if { $res != "" } {
				puts $fd $res
			}
			set res [readsock $news($nts)]
		}	
		set newsread($g,$a) $a
		catch {$wx delete $idx}
		catch {$wx insert $idx "X"}
	}

	close $fd
	disconnect $news($nts);

	$w.s configure -to $totlines -label "filtering "
	update
	set fd [open $fn r ]
	set fn2 "$news(personal)/[clock format [clock seconds] -format %H%M%S].tmp"
	set fd2 [open $fn2 w ]
	set st 0


	#Filter BEGIN and END (note letters)
	set filter 0
	set lcount 0
	while { [gets $fd line] > 0 } {
		incr lcount
		switch $st {
		0 { 
			set bg [string range $line 0 5]
			if { [string compare $bg "BEGIN "] == 0 } {
				set st 1 ; # Looking for END
				incr filter
			} 
		  }
		1 {
			if { $line == "END" } {
				set st 0
				set lcount 0
			} else {
				puts $fd2 $line
			}
		   }
		default {
			puts stderr "Logic error"
			}
		}
	}
	close $fd
	close $fd2

	set news($w,message) "Decoding ..."
	update
	if { $filter == 0 } {
		if [catch {uudecode $fn} dnlst]  {
			set res 1
		} else {
			set res 0
		}
	} else {
		if { [catch {uudecode $fn2} dnlst] } {
			set res 1
		} else {
			set res 0
		}
	}

	if { $res != 0 } {
		tk_dialog .xme "$news(tclnews) $news(version)" "Erorr decoding!\n msg = ($dnlst)" error 0 OK
	} else {
		catch {set news($wo,message) "Decoded $dnlst"}
	}
	update
	file delete $fn
	file delete $fn2

	closewin $nts
}

