
proc getnewgroups {} {
	global news groups sgroups ngroups

	if { ![file exists $news(home)/groups.dat] } {
		return [getallgroups]
	}

	if { [string length $news(grp_date)] != 13 } {
		set news(grp_date) [clock format [clock seconds] -format "%y%m%d %H%M%S" -gmt 1] 
	}
	socksend $news(main) "newgroups $news(grp_date) GMT"
	set res ""
	while { $res == "" } {
		set res [readsock $news(main)]
		set val [string range $res 0 2]
	}

	if { $val != 231 } {
		tk_dialog .nd "$news(tclnews) $news(version)" \
			"Can't get newgroups ($res)" \
			error 0 OK CANCEL] == 0 
		return
	   }

	set news(.news,message) "Reading new groups since $news(grp_date)"
	set fd [open $news(home)/groups.dat a] 
	set news(.news,l1) 0
	set count 0
	while { $res != "." } {
		set res [readsock $news(main)] 
			
		# This will certainly couse problems.  
		# Might be better to close and reopen the connections.
		if { $news(.news,stop) == 1 } { 
			close $fd
			set news(grp_date) [clock format [clock seconds] -gmt 1] 
			set news(.news,message) "Operation Terminated"
			return 
		} 
				
		if { $res != "" && $res != "." } {
			set lst [split $res]
			set g [lindex $lst 0 ]
			set y [lindex $lst 3 ]
			set groups($g) $y
			inslst .news $g 0
			puts $fd "$g $y"
			incr count
		}
		if { $count >= 30 } {
			incr news(.news,l1)  $count
			set count 0
			update
		}
	}
	close $fd
	set news(grp_date) [clock format [clock seconds] -gmt 1] ; # tclsock.so
	set news(.news,message) "Operation Complete"
	return
}

