

#  Mail an article to a news group
#  w is only set for a reply
proc mailart { {rw "" } {g ""} } {
	global news


	set ts  [clock seconds]

	update
	set w [formwindow $ts mail "Mail"  "To:" "Cc:" "Bcc:" "Subject:" "Date:" "Attachment:"]

	set news($w,1) ""
	set news($w,2) ""
	set news($w,3) ""
	set news($w,4) ""
	set news($w,5) "[clock format [clock seconds] -format %c]"
	set news($w,6) ""
	#  Handle a reply
	set hesaid ""

	$w.main insert end "\n"; # Create an empty line at the top
	set count 1

if { $g != "" } {
	set from ""
	set bdy  ""
	set id   ""
	set line [$rw get $count.0 $count.end]
	while { $line != "" } {
		# $w.main insert end ">$line\n"
		set l [split $line : ]
		set hdr [lindex $l 0]
		set bdy [string range $line [expr [string length $hdr] + 1] end] 
		switch $hdr {
			Subject { set news($w,4) [string trim $bdy " "] }
			From    { set from $bdy } 
			Message-ID    { set id $bdy } 
		}
	incr count
	set line [$rw get $count.0 $count.end]
	}

	
	set hesaid [$rw get $count.0 end]
	$w.main insert end "in message $id from $g\n$from wrote:\n"
	foreach line [split $hesaid "\n"] {
		$w.main insert end ">$line\n"
	}
}

	$w.ok configure -text "Send" -command "set news($w,wait) 1"
	$w.cancel configure -command "set news($w,wait) 2"
	bind $w.uf.f6.e  <Tab> "focus $w.main;break"
	focus $w.uf.f1.e 

	set news($w,wait) 0

set ok 0
while { ! $ok } {
	tkwait variable news($w,wait)
	if { $news($w,wait) == 1 } {

		set news($ts) [socket $news(mail) smtp]
		fconfigure $news($ts) -translation crlf
		fconfigure $news($ts) -buffering line
		fconfigure $news($ts) -blocking off

		if { $news(debug) } {
			debugmsg "SMTP -> $news($ts)"
		}

		# Check for a good connection
		set res [readsock $news($ts)]
		if { [rescode $res 220] } {
			disconnect $news($ts)
			closewin $ts
			return ""
		}
		set domain [lindex [split $news(email) @] 1]
		socksend $news($ts) "HELO $domain"
		set res [readsock $news($ts)]
		if { [rescode $res 250] } {
			disconnect $news($ts)
			closewin $ts
			return ""
		}

		socksend $news($ts) "MAIL FROM:<$news(email)>"
		if { [rescode [readsock $news($ts)] 250 ]} {
			disconnect $news($ts)
			closewin $ts
			return ""
		}

		set rok 1
		foreach var [list $news($w,1) $news($w,2) $news($w,3)] {
		foreach rcpt [split $var ","] {
			socksend $news($ts) "RCPT TO:<$rcpt>"
			if { [rescode [readsock $news($ts)] 250 ]} {
				tk_dialog .xxme "$news(tclnews) $news(version)" "$rcpt is not known to $news(mail)" error 0 OK
				set rok 0
			}
		}
		}

		if { $rok } {
			socksend $news($ts) "DATA"
			if { [rescode [readsock $news($ts)] 354] == 0 } {

			socksend $news($ts) "From: $news(name) <$news(email)>"
			socksend $news($ts) "To: $news($w,1)"
			socksend $news($ts) "Cc: $news($w,2)"
			socksend $news($ts) "Subject: $news($w,4)"
			socksend $news($ts) "Date: $news($w,5)"
			socksend $news($ts) ""

			foreach line [split [$w.main get 1.0 end] "\n"] {
				if { $line == "." } {
					set line ".."
				}
				socksend $news($ts) "$line"
			}

			if { [file readable $news($w,6)] } {
				set fd [open $news($w,6) r]
				socksend $news($ts) "-------------   Attachment ($news($w,6)) -------------"
				while { [gets $fd line] >= 0 } {
					if { $line == "." } {
						set line ".."
					}
					socksend $news($ts) "$line"
				}
				close $fd
			}
			
			if { $news(sig) != "" } {
				socksend $news($ts) "$news(sig)"
			}
			socksend $news($ts) "\n."
			if { [rescode [readsock $news($ts)] 250] == 0 } {
				set ok 1
			}
			disconnect $news($ts)
			}
		}
	} else {
		set ok 1 ; # Cancel
	}
	}
	closewin $ts
}

