#!/usr/local/bin/wish4.1 -f

proc readmailfile { w {folder ""} } {
	global news mail env

	if { $folder == "" } {
		set folder $env(MAIL)
	}

	if { ![file readable $folder] } {
		tk_dialog .xxerr "TkMail" "$folder is not readable" error 0 OK
		return err
	}

	
	set fd [open $folder r]
	#Find the first message

	$w.x delete 0 end
	$w.seq delete 0 end
	$w.main delete 0 end

	set count -1;
	set line_count 0
	while { [gets $fd line] >= 0 } {
		set x [string range $line 0 4]
		if { [string compare $x "From "] == 0 } {
			incr count
			set mail($count,id) $line
			
			# read in XX: stuff should stop at the first 
			# empty line
			set count1 0
			while { [gets $fd line] > 0 } {
				incr count1
				set l [split $line :]
				set hdr [lindex $l 0]
				set mail($count,hdr,$count1) $line
				switch $hdr {
					Subject {
						set mail($count,Subject) [string trim [string range $line 9 end] " "]
					}
					Status {
						set mail($count,Status) [string trim [lindex $l 1] " "]
					}
					From 	{
						set mail($count,From) [string trim [lindex $l 1] " "]
					}
				}
			}
			if { ![info exists mail($count,Subject)] } {
				puts "Error no Subject line"
				exit 1
			}
			if { ![info exists mail($count,Status)] } {
				set mail($count,Status) ""
			}
			if { [regexp -nocase {([a-z])+([ ])+([a-z.' ])*([a-z])+} $mail($count,From) x y z ]} {
				set from $x
			} else {
				set from  $mail($count,From)
			}
			$w.main insert $count [format "%-20.20s %s" $from $mail($count,Subject) ]
			$w.x    insert $count $mail($count,Status)
			$w.seq  insert $count ""
			set line_count 0
		} else {
			incr line_count
			set mail($count,line,$line_count) $line
			set mail($count,line_count) $line_count
		}
	}
	close $fd
}

proc read_msg { w1 } {
	global news  mail


foreach idx [$w1.main curselection] {
	set idx $idx

if { [info exists mail($idx,Subject)] } {
	set nts [clock format [clock seconds] -format %H%M%S]
	set w ".$nts"

	window $w readmsg $mail($idx,Subject) text Done Reply Save

	foreach hdr [lsort [array names mail $idx,hdr,*] ] {
		$w.main insert end "$mail($hdr)\n"
	}
	$w.main insert end "\n"

	set news($w,stop) 0
	$w.done configure -command "closewin $nts"
	$w.reply configure -command "mailart $w.main Reply"
	$w.save configure -command "saveart $w"

	for { set l 0 } { $l < $mail($idx,line_count) } { incr l } {
		if { [info exists mail($idx,line,$l)] } {
			$w.main insert end "$mail($idx,line,$l)\n"
		}
	}

	}
	set mail($idx,Status) "R"
	$w1.x   delete $idx 
	$w1.x   insert $idx $mail($idx,Status)

}

}

proc delete_msg { w1 } {
	global news  mail


	foreach idx [$w1.main curselection] {
		set mail($idx,Status) "D"
		$w1.x   delete $idx
		$w1.x   insert $idx $mail($idx,Status)
	}
}


proc maildone { sv } {
	global news mail

	if { $sv == 1 } {
		puts "Save the file"
	}

	closewin tkmail
	unset mail	
}

proc readmail {} {
	global news mail



	# This code is not recursive
	if { [winfo exists .tkmail] } {
		return;
	}
	
	#  Create the application main window
	set win .tkmail
	window $win News Mail listbox  Done Cancel Delete

	$win.cancel configure -command "maildone 0"
	$win.done  configure -command "maildone 1"
	$win.delete  configure -command "delete_msg $win"
	set mail(glst) $win.main
	bind $mail(glst) <Double-1> { read_msg .tkmail }
	bind $mail(glst) <3> { button3 %W %x %y {read_msg .tkmail} }

menubutton .tkmail.uf.m3 -text File -relief raised -menu .tkmail.uf.m3.m
set m [menu  .tkmail.uf.m3.m -tearoff 1]
$m add command -label "News Message" -command mailart
$m add command -label "Open Folder" -command openfolder
$m add command -label "Save as" -command "savemail 1"
$m add command -label "Save" -command "savemail 0"
$m add separator
$m add command -label "Quit Mail" -command "maildone 1"
$m add command -label "Quit Mail Without Saving" -command "maildone 0"
pack .tkmail.uf.m3 -in .tkmail.uf -anchor nw -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
#------------------------------------------

menubutton .tkmail.uf.m4 -text Options -menu .tkmail.uf.m4.m -relief raised
set m [menu  .tkmail.uf.m4.m -tearoff 1]
$m add command -label "Setup" -command tclnews_setup
$m add check -label "Save read articles" -variable news(mail,save)
$m add command -label "Check Mail" -command checkmail
$m add command -label "Forget Password" -command {set news(poppass) ""}
pack .tkmail.uf.m4 -in .tkmail.uf -anchor nw -expand 0 -fill x -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left

	readmailfile  $win
}

readmail
	



